<!DOCTYPE html>
<html>
<head>
<title>Glaze Tracker Admin - Students</title>
<!-- ############### -->
<!-- BEGIN BOOTSTRAP -->
<!-- ############### -->
<!-- Latest compiled and minified CSS -->
<link rel="stylesheet" href="bootstrap-3.3.6-dist/css/bootstrap.min.css" integrity="sha384-1q8mTJOASx8j1Au+a5WDVnPi2lkFfwwEAa8hDDdjZlpLegxhjVME1fgjWPGmkzs7" crossorigin="anonymous">

<!-- Optional theme -->
<link rel="stylesheet" href="bootstrap-3.3.6-dist/css/bootstrap-theme.min.css" integrity="sha384-fLW2N01lMqjakBkx3l/M9EahuwpSfeNvV63J5ezn3uZzapT0u7EYsXMjQV+0En5r" crossorigin="anonymous">

<!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
<script src="jquery-1.11.3.min.js"></script>

<!-- Latest compiled and minified JavaScript -->
<script src="bootstrap-3.3.6-dist/js/bootstrap.min.js" integrity="sha384-0mSbJDEHialfmuBBQP6A4Qrprq5OVfW37PRR3j5ELqxss1yVqOtnepnHVP9aJ7xS" crossorigin="anonymous"></script>
<!-- ############# -->
<!-- END BOOTSTRAP -->
<!-- ############# -->

<!-- bootbox gives us a pretty, bootstrap-style modal dialogs -->
<script src="bootbox.js"></script>

<style>
h4 {
  margin-top: 25px;
}
.row {
  margin-bottom: 20px;
}
.row .row {
  margin-top: 10px;
  margin-bottom: 0;
}
[class*="col-"] {
  padding-top: 15px;
  padding-bottom: 15px;
  background-color: #eee;
  background-color: rgba(86,61,124,.15);
  border: 1px solid #ddd;
  border: 1px solid rgba(86,61,124,.2);
}
hr {
  margin-top: 40px
  margin-bottom: 40px;
}
</style>
<script>
function onLoadHandler() {
	// Load the class list
	$.post("/glazeServer.php", {action: "classList"}, processClassList, "json")
		.error(function(){alert("Uh oh, I couldn't get the class list!  Please report this.");});
}
var knownClasses = {};
function processClassList(data) {
	for (rowIdx in data) {
		row = data[rowIdx];
		idclasses = row.idclasses;
		classname = row.classname;
		knownClasses[idclasses] = classname;
	}
	// Load the potter list
	$.post("/glazeServer.php", {action: "adminPotterList"}, processPotterList, "json")
		.error(function(){alert("Uh oh, I couldn't get the student list!  Please report this.");});
}
function addPotter() {
        var pottername = $("#newPotterName").val();
        if (pottername == "" || pottername == undefined) {
                bootbox.alert("<span class='glyphicon glyphicon-warning-sign' style='color: red' aria-hidden='true'> </span> Please enter the potter's name.");
                return;
        }
        var potterclass = $("#newPotterClassSelect option:selected").val();
        if (potterclass == -1) {
                bootbox.alert("<span class='glyphicon glyphicon-warning-sign' style='color: red' aria-hidden='true'> </span> Please choose a class for the new potter.");
                return;
        }
        var potteractive = $("#newPotterActive").prop("checked");
	bootbox.dialog({
		message: "Adding potter...",
		title: "Please wait...",
		closeButton: false
	});
        var requestData = {action: "adminAddPotter",
                           pottername: pottername,
                           idclasses: potterclass,
                           potteractive: potteractive}
        $.post("/glazeServer.php", requestData, function(data) { location.reload();})//, "json")
                                    .error(function(xhr, txt, err){
                                                alert("Uh oh, I couldn't add the potter!  Please report this.");
                                                //alert(txt+"\n"+err);
                                                });
}
function updatePotter(idpotters) {
        var pottername = $("#potter"+idpotters+"name").val();
        var potterclass = $("#potter"+idpotters+"classSelect option:selected").val();
        var potteractive = $("#potter"+idpotters+"active").prop("checked");
	bootbox.dialog({
		message: "Updating info...",
		title: "Please wait...",
		closeButton: false
	});
        $.post("/glazeServer.php", {action: "adminUpdatePotter",
                                    idpotters: idpotters,
                                    pottername: pottername,
                                    idclasses: potterclass,
                                    potteractive: potteractive}, updatePotterDone)//, "json")
                                    .error(function(xhr, txt, err){
                                                alert("Uh oh, I couldn't update the potter info!  Please report this.");
                                                //alert(txt+"\n"+err);
                                                });
}
function updatePotterDone(data) {
        alert(data);
        bootbox.hideAll();
	if ("errNo" in data && data.errNo == 0) {
                // Success!
                bootbox.dialog({
                        message: data.msg,
                        title: "Done!",
                        buttons: {
                                anotherSlip: {
                                        label: "OK!",
                                        className: "btn-success",
                                        callback: function() {}
                                }
                        }
                });
	} else {
		// Something went wrong
		if ("errNo" in data) {
			// Something went wrong, but the server can explain it to us
			bootbox.dialog({
				message: "<span class='glyphicon glyphicon-warning-sign style='color: red' aria=hidden='true'> </span> " + data.msg + "<br>\n<br>\n<div class='text-muted'>Technical details for geeks:<br>\n" + data.errNo + "<br>" + data.errMsg + "</div>",
				title: "Uh oh!  Something went wrong...",
				buttons: {
					closeDialog: {
						label: "OK",
						callback: function() {}
					}
				}
			});
			return;
		} else {
			// Something went REALLY wrong, no error code from the server
			bootbox.dialog({
				message: "<span class='glyphicon glyphicon-warning-sign style='color: red' aria=hidden='true'> </span> " + data.msg + "<br>\n<br>\n<div class='text-muted'>Technical details for geeks:<br>\n" + data + "</div>",
				title: "Uh oh!  Something went wrong (but I'm not sure what)...",
				buttons: {
					closeDialog: {
						label: "OK",
						callback: function() {}
					}
				}
			});
			return;
		}
	}
}

function processPotterList(data) {
	for (rowIdx in data) {
		row = data[rowIdx];
		idpotters = row.idpotters;
		potterclass = row.potterclass;
		pottername = row.pottername;
                potteractive = true; // Future support for deactivating potters
		$("#tablePotters > tbody:last-child")
                        .append(($("<tr>"))
                                        .append($("<td>").text(idpotters))
                                        .append($("<td>")
                                                .append($("<input>").attr({
                                                                           type: "text",
                                                                           id: "potter"+idpotters+"name",
                                                                           value: pottername,
                                                                           class: "form-control"
                                                                           }))
                                               )
                                        .append($("<td>")
                                                .append($("<select>").attr({
                                                                            id: "potter"+idpotters+"classSelect",
                                                                            class: "form-control"
                                                                            })
                                                       )
                                               )
                                        .append($("<td>")
                                                .append($("<input>").attr({
                                                                          type: "checkbox",
                                                                          id: "potter"+idpotters+"active",
                                                                          class: "form-control",
                                                                          checked: potteractive
                                                                          })
                                                       )
                                                )
                                        .append($("<td>")
                                                .append($("<input>")
                                                          .attr({
                                                               type: "button",
                                                               class: "btn btn-primary",
                                                               value: "Update potter",
                                                               onclick: "updatePotter("+idpotters+")"
                                                               })
                                                       )
                                               )
                               );
                sel = $("#potter"+idpotters+"classSelect");
                for (idclasses in knownClasses) {
                        opt = $("<option>").text(knownClasses[idclasses]).attr("value", idclasses);
                        if (idclasses == potterclass) {
                                opt.attr("selected", "selected");
                        }
                        sel.append(opt);
                }
	}
        // Populate the "add student" class list
        sel = $("#newPotterClassSelect");
        for (idclasses in knownClasses) {
                opt = $("<option>").text(knownClasses[idclasses]).attr("value", idclasses);
                sel.append(opt);
        }
}

$( document  ).ready(onLoadHandler);
</script>
<body>
<?php include("header.php"); ?>
<div class="container">
    <div class="page-header">
        <h1>ACTIVE is not useful yet!!!</h1>
        <h1>Glazeware Tracker Adminstration - Students</h1>
        <h1>ACTIVE is not useful yet!!!</h1>
    </div>
    <div class="row">
        <!-- Potter -->
        <div class="col-md-8 form-group">
            <h3>Students:</h3>
            <table class='table' id="tablePotters">
                <tbody>
                <tr>
                    <th>id</th>
                    <th>name</th>
                    <th>class</th>
                    <th>active</th>
                </tr>
                <tr>
                    <!-- Firefox preserves the "disabled" state of buttons across reloads unless you disable autocomplete.  We want clear EVERYTHING.  Since we don't need autocomplete anyway, disabling it is a fine workaround.  -->
                    <form autocomplete="off">
                    <td>-</td>
                    <td><input type="text" class="form-control" id="newPotterName" placeholder="Potter name"></td>
                    <td><select class="form-control" id="newPotterClassSelect">
                        <option value="-1" class="text-muted">-Pick one-</option>
                    </select></td>
                    <td><input type="checkbox" class="form-control" id="newPotterActive" checked></td>
                    <td><input type="button" class="btn btn-default btn-success" value="Add potter" onclick="addPotter()"></td>
                    </form>
                </tr>
                </tbody>
            </table>
        </div>
    </div>
</div>
</body>
</html>
