<?php
$KNOWN_STUDENTS_ONLY = True;
?>
<!DOCTYPE html>
<html>
<head>

<!--

So... if you're reading this, there are a few things you should know:
 1. I don't know bootstrap.js
 2. I don't know jquery
 3. I haven't used SQL in many years
 4. I haven't used PHP in many years
 5. This is written using bootstrap.js, jquery, mysql, and PHP

Random notes:
* Do people want/need to edit slips?  Will they tolerate having to do the slip later?
* Whiteboard marker for people to not forget in-progress pieces until they fill out the form?

Thought process:
* Interface on cheap tablet, connected to charger
* Server on Raspberry PI, connected to printer
	* Server prints the barcode when the database insertion works
* Or, server /anywhere/, and printer on WiFi / LAN

Hours:
	~3 on 12/2
		Mocked up web page
	~3 on 12/6
		Installed PHP, side copy of Apache for PHP, MySQL
		Built DB schema
		Started adding actual app logic
			Populate class list from DB, sanity check name & class choice against DB
	~3-4 on 12/7
		Built all(?) client side app logic
	~4 on 12/8
		Receipt printer research
		   Product page:
		      http://www.citizen-systems.com/us/printer/pos/ct-s601
		   Sales sheet:
		      http://www.citizen-systems.com/sites/default/files/CT-S601_SellSheet_0.pdf
		   Raw command documentation:
		      http://www.citizen-systems.com/sites/default/files/CommandReference015E_120607_4.pdf
		   User manual:
		      http://www.citizen-systems.com/sites/default/files/CT-S601_UME_TZ74916-00F.pdf
		   WiFi interface:
		      http://www.citizen-systems.co.jp/english/support/download/printer/utility/software/data/IF1-WF01_UsersManual_en.pdf
		   Ethernet / LAN interface:
		      http://www.citizen-systems.co.jp/english/support/download/printer/document/user/data_if/IF1-ET01_UM_TZ74936-00F.pdf
		Built server side of pot insertion (with potter class updates / inserts)
	~3 on 12/9
		Bought printer (~1hr, mostly driving time, $100)
		Got slips printing in a decent format
	~2 on 12/10
		Quick reporter, CSV downloader
	~4 on 12/13
		Enhance reporter a bit
		Create an admin page
		Updates for Kit (no "bought at ClayWays" or "High Fire", add date to slip)
		Begin handling some errors (e.g. can't reach printer) a little better
	~2 on 12/15
		Add printer IP and port to admin page
		Some initial *very* rough error-handling on the admin page
	~1 on 1/11
		Keyup handling, so that we don't wait for "change" events
		Weight sanity checking, usability improvement
Next major steps:
	* Mark pots as fired
		* Need extra columns in DB...do we also want to track kiln loads?
		* Otherwise just an extra date field on each pot
	* Error handling, if we can't reach the webserver in any $.post() or other XHR calls
	* Reduce magnification of barcode if we want to stash more data. "GS w n"
	* Ask printer for its status?  "DLE EOT n", "ESC v"
-->

<title>Glaze Tracking</title>

<!-- To ensure proper rendering and touch zooming on mobile devices, add the viewport meta tag -->
<meta name="viewport" content="width=device-width, initial-scale=1">

<!-- ############### -->
<!-- BEGIN BOOTSTRAP -->
<!-- ############### -->
<!-- Latest compiled and minified CSS -->
<link rel="stylesheet" href="bootstrap-3.3.6-dist/css/bootstrap.min.css" integrity="sha384-1q8mTJOASx8j1Au+a5WDVnPi2lkFfwwEAa8hDDdjZlpLegxhjVME1fgjWPGmkzs7" crossorigin="anonymous">

<!-- Optional theme -->
<link rel="stylesheet" href="bootstrap-3.3.6-dist/css/bootstrap-theme.min.css" integrity="sha384-fLW2N01lMqjakBkx3l/M9EahuwpSfeNvV63J5ezn3uZzapT0u7EYsXMjQV+0En5r" crossorigin="anonymous">

<!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
<script src="jquery-1.11.3.min.js"></script>

<!-- Latest compiled and minified JavaScript -->
<script src="bootstrap-3.3.6-dist/js/bootstrap.min.js" integrity="sha384-0mSbJDEHialfmuBBQP6A4Qrprq5OVfW37PRR3j5ELqxss1yVqOtnepnHVP9aJ7xS" crossorigin="anonymous"></script>
<!-- ############# -->
<!-- END BOOTSTRAP -->
<!-- ############# -->

<!-- bootbox gives us a pretty, bootstrap-style modal dialogs -->
<script src="bootbox.js"></script>

<!-- convenient helper library to bind events with delays, used for keyup events -->
<script src="bindWithDelay.js"></script>

<style>
/* Taken from the bootstrap grid demo. */
h4 {
  margin-top: 25px;
}
.row {
  margin-bottom: 20px;
}
.row .row {
  margin-top: 10px;
  margin-bottom: 0;
}
[class*="col-"] {
  padding-top: 15px;
  padding-bottom: 15px;
  background-color: #eee;
  background-color: rgba(86,61,124,.15);
  border: 1px solid #ddd;
  border: 1px solid rgba(86,61,124,.2);
}
hr {
  margin-top: 40px;
  margin-bottom: 40px;
}

/* ########## */
/* My changes */
/* ########## */
/* Fade the "Print it" button more when disabled */
#printButton[disabled] {
 opacity: 0.4;
}
/* Disable the up and down arrows on the Weight number input */
/* so people don't think they need to click "up" 400 times. */
#inputWeight {
	-moz-appearance: textfield;
}
#inputWeight::-webkit-inner-spin-button, 
#inputWeight::-webkit-outer-spin-button { 
  -webkit-appearance: none; 
  margin: 0; 
}

</style>

<script>
// The clear button just reloads the page to wipe everything out.
function clearButtonHandler() {
	bootbox.dialog({
		message: "Are you sure you want to clear the form?",
		buttons: {
			clear: {
				label: "Clear everything!",
				className: "btn-danger",
				callback: function() {
					location.reload();
				}
			},
			keep: {
				label: "Don't clear it",
				className: "btn-primary",
				callback: function() {
					// Do nothing.
				}
			}
		}
	});
}

// Check whether all the fields are good and we can print a slip
function validateEverything() {
	bad = [];
	// Commented out code not supported by Internet Explorer.
	//for (selector of ["#inputClass option:selected", "#inputName", "#inputClayType option:selected", "#inputWeight", "#inputPotDesc", "#inputGlazes"]) {
	var selectorArr = ["#inputClass option:selected", "#inputName", "#inputClayType option:selected", "#inputWeight", "#inputPotDesc", "#inputGlazes"];
	for (selectorIdx in selectorArr) {
		var selector = selectorArr[selectorIdx];
		// This is quick & dirty.  The "Clay Type" and "Class" inputs use -1
		if ($(selector).val() == "" || $(selector).val() == -1) {
			bad.push(selector);
		}
	}
	// For weights, also ensure the pot weighs at least 1 gram.  Otherwise, they
	// might have entered kilograms.
	if ($("#inputWeight").val() < 1) {
		bad.push("#inputWeight");
	}
	return (bad.length == 0) ? true : false;
}

// When they type their name, check whether we know them or not. This
// should help deal with regular users typo'ing their names, although
// people are still free to deliberately use made-up names...
function updateKnownName(data) {
	if (data.length == 0) {
		// We don't know them at all
		$("#inputNameGroup").removeClass("has-success has-warning").addClass("has-error");
		$("#helpBlockName").html("I've never met you before!  Did you mistype your name?  If you're new to ClayWays, I'll remember you next time, I promise!");
	} else {
		knownClassId = data[0].idclasses;
		claimedClassId = $("#inputClass option:selected").val();
		if (knownClassId != claimedClassId) {
			knownClassName = data[0].classname;
			claimedClassName = $("#inputClass option:selected").text();
			$("#helpBlockName").html("Hey, you said you're in " + claimedClassName + ", but I thought you're really in " + knownClassName + "!");
			$("#inputNameGroup").removeClass("has-success has-error").addClass("has-warning");
		} else {
			$("#helpBlockName").html("Welcome back, " + $("#inputName").val() + "!");
			$("#inputNameGroup").removeClass("has-warning has-error").addClass("has-success");
		}
	}
	// Whether or not we know them, enable the rest of the form
	$("#inputClayType").removeAttr("disabled");
	$("#inputWeight").removeAttr("disabled");
	$("#inputPotDesc").removeAttr("disabled");
	$("#inputGlazes").removeAttr("disabled");
}
function nameChangeHandler() {
	potterName = $("#inputName").val();
<?php
if ($KNOWN_STUDENTS_ONLY != True) {
?>
	if (potterName != "") {
		$.post("/glazeServer.php", {action: "nameCheck", potterName: potterName}, updateKnownName, "json");
	} else {
		$("#helpBlockName").html("");
		$("#inputNameGroup").removeClass("has-error has-warning has-success");
		$("#inputClayType").attr("disabled", "disabled");
		$("#inputWeight").attr("disabled", "disabled");
		$("#inputPotDesc").attr("disabled", "disabled");
		$("#inputGlazes").attr("disabled", "disabled");
	}
<?php
} else {
?>
	if (potterName != -1) {
		$("#helpBlockName").html("");
		$("#inputNameGroup").removeClass("has-warning has-error").addClass("has-success");
		// Since we know who they are, enable the form
		$("#inputClayType").removeAttr("disabled");
		$("#inputWeight").removeAttr("disabled");
		$("#inputPotDesc").removeAttr("disabled");
		$("#inputGlazes").removeAttr("disabled");
	} else {
		$("#inputNameGroup").removeClass("has-success has-warning").addClass("has-error");
		// Disable the form
		$("#inputClayType").attr("disabled", "disabled");
		$("#inputWeight").attr("disabled", "disabled");
		$("#inputPotDesc").attr("disabled", "disabled");
		$("#inputGlazes").attr("disabled", "disabled");
	}
<?php
}
?>
}
// If the user has picked a class, allow them to enter their name.
function classChangeHandler() {
	chosenClass = $("#inputClass option:selected").val();
	if (chosenClass == -1) {
		$("#inputClassGroup").removeClass("has-warning has-success").addClass("has-error");
		$("#inputName").removeClass("has-error has-warning has-success");
		if ($("#inputName").val() == "") { $("#inputName").attr("disabled", "disabled"); }
		return;
	}
	$("#inputClassGroup").removeClass("has-warning has-error").addClass("has-success");
	// In the future, we could make the Name field a dropdown list
	// that users choose from (i.e. the database knows who's in
	// each class).  For now, let's just add users to the database
	// as we encounter them (but let the user know if we have seen
	// them before?)
	$("#inputName").removeAttr("disabled");
	// Set up the change handler, so we can check whether or not
	// we've seen this user before.
	$("#inputName").change(nameChangeHandler);
<?php
if ($KNOWN_STUDENTS_ONLY != True) {
?>
	// Also handle keyup so the user doesn't have to take extra steps
	// that produce a 'change' event, but delay slightly so we don't
	// slam the server.
	$("#inputName").bindWithDelay("keyup", nameChangeHandler, 750);
<?php
}
?>
	// De-select their clay.  This is a bit of a hack, but it's an easy way
	// for us to re-run the clay <=> class (high fire, mid range) again.  We
	// could do something more clever, but hopefully people don't change
	// their Class choice much.
	$("#inputClayType").val(-1);
<?php
if ($KNOWN_STUDENTS_ONLY != True) {
?>
	// Call the change handler once immediately, in case they're fixing
	// their class selection after typing their name.
	nameChangeHandler();
<?php
} else {
?>
	// Fetch the list of students for this class
	// but clear any previous selection and remove existing students in
	// case this isn't the first time a class has been chosen
	$("#inputName").val(-1);
	$("#inputName>option[value != -1]").remove();
	// Call the name change handler to disable the form and fix the coloring
	nameChangeHandler();
	$.post("/glazeServer.php", {action: "potterList", idclasses: chosenClass}, processPotterList, "json");
<?php
}
?>
}
<?php
if ($KNOWN_STUDENTS_ONLY == True) {
?>
function processPotterList(data) {
	for (rowIdx in data) {
		row = data[rowIdx];
		idpotters = row.idpotters;
		pottername = row.pottername;
		newOption = $("<option>");
		newOption.text(pottername).attr("value", pottername);
		$("#inputName").append(newOption);
	}
}
<?php
}
?>
// Populate the class list dropdown, once the server returns data.
function processClassList(data) {
	for (rowIdx in data) {
		row = data[rowIdx];
		idclasses = row.idclasses;
		classname = row.classname;
		claytype = row.claytype;
		claytypedesc = row.description;
		newOption = $("<option>");
		newOption.data({type: claytype, desc: claytypedesc});
		$("#inputClass").append(newOption
					 .text(classname)
					 .attr("value", idclasses));
	}
}
function clayChangeHandler() {
	chosenClayObj = $("#inputClayType option:selected");
	chosenClay = chosenClayObj.val();
	chosenClayName = chosenClayObj.text();
	chosenClayType = chosenClayObj.data().type;
	chosenClayTypeDesc = chosenClayObj.data().desc;

	chosenClassObj = $("#inputClass option:selected");
	classClayType = chosenClassObj.data().type;
	classClayTypeDesc = chosenClassObj.data().desc;

	// null classes allow all clays.  null clays haven't been set up yet.
	// We can only check fully-configured clays against restricted-clay classes
	if (classClayType != null && chosenClayType != null) {
		if (chosenClayType != classClayType) {
			bootbox.dialog({
				message: "You chose a <b>" + chosenClayTypeDesc + "</b> clay, but you're in a class that uses <b>" + classClayTypeDesc + "</b> clays.  Are you sure you're really using this clay?",
				title: "This clay might not be what you want!",
				buttons: {
					clear: {
						label: "I'm sure!",
						className: "btn-danger",
						callback: function() {
							// Do nothing.
						}
					},
					keep: {
						label: "Oops, I want a " + classClayTypeDesc + " clay",
						className: "btn-primary",
						callback: function() {
							// De-select their clay
							$("#inputClayType").val(-1);
						}
					}
				}
			});
		}
	}
	if (chosenClay == -1) {
		$("#inputClayTypeGroup").removeClass("has-warning has-success").addClass("has-error");
	} else if (chosenClayName == "Other") {
		$("#inputClayTypeGroup").removeClass("has-error has-success").addClass("has-warning");
	} else {
		$("#inputClayTypeGroup").removeClass("has-warning has-error").addClass("has-success");
	}
}
// Populate the clay list dropdown, once the server returns data
function processClayList(data) {
	for (rowIdx in data) {
		row = data[rowIdx];
		idclays = row.idclays;
		clayname = row.clayname;
		claytype = row.claytype;
		claytypedesc = row.description;
		newOption = $("<option>");
		$("#inputClayType").append(newOption
					    .text(clayname)
					    .attr({value: idclays}));
		newOption.data({type: claytype, desc: claytypedesc});
	}
	// Set up the change handler, so that we can populate the names
	$("#inputClayType").change(clayChangeHandler);
}

// If they want to print:
//   1. Re-run the validator.  The button *should* be disabled and un-clickable if the
//      form isn't valid, but this is a safety-net to catch bugs.
//   2. Put up a modal dialog so they can't interact with anything
//   3. Send the data to the server.  The callback function will find out if
//      the server was happy, and remove the modal dialog.
function printButtonHandler() {
	// Re-run validator
	if (!validateEverything()) {
		// Crud.  Ask the user to record a video showing how they broke the form, so we can reproduce the bug.
		bootbox.dialog({
			message: "I was about to let you print a glaze slip, even though the form isn't filled out properly.  If you can figure out how to re-create this problem, please record a video so the author of this program can figure out what exactly went wrong!",
			title: "Oh no!",
			closeButton: false,
			buttons: {
				close: {
					label: "Close this dialog and reset the form",
					className: "btn-danger",
					callback: function() {location.reload();}
				}
			}
		});
		return;
	}
	// Put up a modal dialog...
	bootbox.dialog({
		message: "Printing your glaze slip...",
		title: "Please wait...",
		closeButton: false
	});
	// Send data to the server
	idclasses = $("#inputClass option:selected").val();
	name = $("#inputName").val();
	idclays = $("#inputClayType").val();
	weight = $("#inputWeight").val();
	description = $("#inputPotDesc").val();
	glazes = $("#inputGlazes").val();
	requestDetails = {
		action: "printSlip",
		idclasses: idclasses,
		potterName: name,
		idclays: idclays,
		weight: weight,
		description: description,
		glazes: glazes
	};
	// NOTE: We expect JSON back
	// TODO FIXME: Add a .error() handler for the parse error that happens if we get back raw
	// text here, instead of the expected JSON?
	$.post("/glazeServer.php", requestDetails, printCallback, "json");
}
function printCallback(data) {
	bootbox.hideAll();
	if ("errNo" in data && data.errNo == 0) {
		// Success!
		bootbox.dialog({
			message: data.msg,
			title: "Done!",
			buttons: {
				anotherSlip: {
					label: "I have another pot",
					className: "btn-success",
					callback: function() {}
				},
				clearForm: {
					label: "I'm done, clear the form",
					callback: function() {
						location.reload();
					}
				}
			}
		});
	} else {
		// Something went wrong
		if ("errNo" in data) {
			// Something went wrong, but the server can explain it to us
			bootbox.dialog({
				message: "<span class='glyphicon glyphicon-warning-sign' style='color: red' aria-hidden='true'> </span> " + data.msg + "<br>\n<br>\n<div class='text-muted'>Technical details for geeks:<br>\n" + data.errNo + "<br>" + data.errMsg + "</div>",
				title: "Uh oh!  Something went wrong...",
				buttons: {
					closeDialog: {
						label: "OK",
						callback: function() {}
					}
				}
			});
			return;
		} else {
			// Something went REALLY wrong, no error code from the server
			bootbox.dialog({
				message: "<span class='glyphicon glyphicon-warning-sign' style='color: red' aria-hidden='true'> </span> " + data.msg + "<br>\n<br>\n<div class='text-muted'>Technical details for geeks:<br>\n" + data + "</div>",
				title: "Uh oh!  Something went wrong (but I'm not sure what)...",
				buttons: {
					closeDialog: {
						label: "OK",
						callback: function() {}
					}
				}
			});
			return;
		}
	}
	// They may have updated their class.  Run the name
	// change handler again to re-do the check (which will
	// always welcome them back, since even if they entered
	// something new, the database now holds their new info)
	nameChangeHandler();
}

function onLoadHandler() {
	// Populate the Date field
	// NOTE: If the browser you use doesn't suport toLocaleDateString(),
	// then using toDateString() instead is fine.
	$("#inputDate").attr("value", (new Date(Date.now())).toDateString())

	// Populate the class field
	$.post("/glazeServer.php", {action: "classList"}, processClassList, "json");

	// Populate the clay field
	$.post("/glazeServer.php", {action: "clayList"}, processClayList, "json");

	// Class change handler
	$("#inputClass").change(classChangeHandler);

	// Weight, Description, and Glazes handler
	//$("#inputWeight").on("keyup change", textInputHandler);
	$("#inputWeight").on("keyup change", weightChangeHandler);
	$("#inputPotDesc").on("keyup change", textInputHandler);
	$("#inputGlazes").on("keyup change", glazeChangeHandler);

	// Each time anything changes, re-validate the form and enable/disable
	// the Print button.
	$("input, select, textarea").on("keyup change", function() {
		if (validateEverything()) {
			$("#printButton").removeAttr("disabled");
		} else {
			$("#printButton").attr("disabled", "disabled");
		}
	});

	$("#printButton").click(printButtonHandler)
}
function textInputHandler(event) {
	// Figure out which input we're on
	input = $( this ).attr("id");
	// TODO FIXME We want to get the "group" for the input, to set CSS classes there.
	//            This is probably not the best way to do it.
	inputGroup = "#" + input + "Group";
	if ($( this ).val() == "") {
		$(inputGroup).removeClass("has-warning has-success").addClass("has-error");
	} else {
		$(inputGroup).removeClass("has-warning has-error").addClass("has-success");
	}
}
function glazeChangeHandler(event) {
	// TODO FIXME We want to get the "group" for the input, to set CSS classes there.
	//            This is probably not the best way to do it.
	inputGroup = "#inputGlazesGroup";
	var problem;
	if ($( this ).val() == "") {
		// Empty is not allowed
		$(inputGroup).removeClass("has-warning has-success").addClass("has-error");
		$("#helpBlockGlazes").html("Be descriptive.  Did you dip the piece or pour glaze?  Are the inside and outside the same?  Did you use any washes or oxides?");
	} else if ($( this ).val().split(" ").length < 4) {
		$(inputGroup).removeClass("has-error has-success").addClass("has-warning");
		$("#helpBlockGlazes").html("<b>Use a few more words.</b>  Did you dip it (the whole thing, or just half of it?)?  Did you pour glaze on the inside?");
	} else {
		$(inputGroup).removeClass("has-warning has-error").addClass("has-success");
		$("#helpBlockGlazes").html("");
	}
}
function weightChangeHandler(event) {
	// TODO FIXME We want to get the "group" for the input, to set CSS classes there.
	//            This is probably not the best way to do it.
	inputGroup = "#inputWeightGroup";
	var problem;
	if ($( this ).val() == "") {
		$(inputGroup).removeClass("has-warning has-success").addClass("has-error");
		$("#helpBlockWeight").html("Probably between 100 and 2000.");
	} else if ($( this ).val().match(/\./)) {
		$(inputGroup).removeClass("has-warning has-success").addClass("has-error");
		$("#helpBlockWeight").html("Whole numbers only, please!  <b>If your weight is in kilograms, multiply it by 1000.</b>");
	} else if ($( this ).val() < 50) {
		$(inputGroup).removeClass("has-error has-success").addClass("has-warning");
		$("#helpBlockWeight").html("50 grams is VERY light.  Is this pot tiny?");
	} else if ($( this ).val() > 2000) {
		$(inputGroup).removeClass("has-error has-success").addClass("has-warning");
		$("#helpBlockWeight").html("2000 grams is about 4 pounds.  Is this pot huge?");
	} else {
		$(inputGroup).removeClass("has-warning has-error").addClass("has-success");
		$("#helpBlockWeight").html("");
	}
}

$( document  ).ready(onLoadHandler);
</script>


</head>
<body>
<div class="container">
	<div class="page-header">
		<h1>Glazeware Tracker</h1>
	</div>
      <p>Please fill out this form and tap "Print slip" to print your tracking slip.</p>
      <!-- Firefox preserves the "disabled" state of buttons across reloads unless you disable autocomplete.  We want clear EVERYTHING.  Since we don't need autocomplete anyway, disabling it is a fine workaround.  -->
      <form autocomplete="off">
      <div class="row">
	<!-- column widths add up to 12 -->
        <div class="col-md-4 form-group has-error" id="inputClassGroup"><label for="inputClass" class="control-label">Class</label>
	<select class="form-control" id="inputClass">
		<option value="-1">-Please select-</option>
	</select></div>
        <div class="col-md-4 form-group has-error" id="inputNameGroup">
<?php
if ($KNOWN_STUDENTS_ONLY != True) {
?>
		<label for="inputName" class="control-label">Name</label>
		<input type="text" class="form-control" id="inputName" placeholder="Your Name" disabled="disabled">
		<span id="helpBlockName" class="help-block"></span>
<?php
} else {
?>
		<label for="inputName" class="control-label">Name</label>
		<select class="form-control" id="inputName" disabled="disabled">
			<option value="-1">-Please select-</option>
		</select>
		<span id="helpBlockName" class="help-block"></span>
<?php
}
?>
	</div>
        <div class="col-md-4 form-group has-success" id="inputDateGroup"><label for="inputDate" class="control-label">Date</label> <input type="text" class="form-control" id="inputDate" disabled="disabled" value="DATEHERE"></div>
      </div>
      <div class="row">
        <div class="col-md-4 form-group has-error" id="inputClayTypeGroup">
		<label for="inputClayType" class="control-label">Clay type</label>
		<select class="form-control" id="inputClayType" disabled="disabled">
			<option value="-1">-Please select-</option>
		</select>
	</div>
      </div>
      <div class="row">
        <div class="col-md-2 form-group has-error" id="inputWeightGroup">
		<label for="inputWeight" class="control-label">Weight (grams)</label>
		<input type="number" class="form-control" id="inputWeight" placeholder="Weight (grams)" disabled="disabled">
		<span id="helpBlockWeight" class="help-block"></span>
	</div>
        <div class="col-md-3 form-group has-error" id="inputPotDescGroup">
		<label for="inputPotDesc" class="control-label">Description of pot</label>
		<input type="text" class="form-control" id="inputPotDesc" placeholder="Mug, Pitcher, Cylinder with lid, etc." disabled="disabled">
	</div>
        <div class="col-md-7 has-error" id="inputGlazesGroup">
		<label for="inputGlazes" class="control-label">Glazes (be descriptive)</label>
 		<textarea class="form-control" rows="3" id="inputGlazes" placeholder="Dipped whole pot in Glick Blue, then dipped left half in buttermilk.  " disabled="disabled"></textarea>
		<span id="helpBlockGlazes" class="help-block"></span>
	</div>
      </div>
	<p>
		<input id="printButton" class="btn btn-lg btn-danger" type="button" value="Print slip" disabled="disabled">
		<input id="clearButton" class="btn btn-lg btn-primary" type="button" value="Clear form" onclick="clearButtonHandler()">
	</p>
	</form>
</div><!-- container -->
</body>
</html>
